#/bin/bash

set -x

h="$(dirname $0)"
force=false
: ${bd:=build}
: ${PREFIX:=$HOME/.local}
eval set -- $(getopt -o b:fp: -l buildir:,force,prefix: -- "$@") || exit
while :; do
	case "$1" in
	-b|--buildir) bd="$2"; shift;;
	-f|--force) force=true;;
	-p|--prefix) PREFIX="$2"; shift;;
	--) shift; break;;
	esac
	shift
done

cd "$h"
h=$(pwd)
mkdir -p "$bd" || exit
cd "$bd" || exit

$force && { rm -r * 2>/dev/null || rm CMakeCache.txt 2>/dev/null; }
test -f CMakeCache.txt -a -f Makefile || \
cmake \
	-DCMAKE_INSTALL_PREFIX=${CMAKE_INSTALL_PREFIX:=$PREFIX} \
	-DCMAKE_BUILD_TYPE=${CMAKE_BUILD_TYPE:=Debug} \
	-DWITH_SYSTEMD=${WITH_SYSTEMD:=ON} \
	-DWITHOUT_CYNAGORA=${WITHOUT_CYNAGORA:=OFF} \
	-DWITHOUT_TESTS=${WITHOUT_TESTS:=OFF} \
	-DWITH_AFB_HOOK=${WITH_AFB_HOOK:=ON} \
	-DWITH_SIG_MONITOR_SIGNALS=${WITH_SIG_MONITOR_SIGNALS:=ON} \
	-DWITH_SIG_MONITOR_FOR_CALL=${WITH_SIG_MONITOR_FOR_CALL:=ON} \
	-DWITH_SIG_MONITOR_TIMERS=${WITH_SIG_MONITOR_TIMERS:=ON} \
	-DWITH_AFB_TRACE=${WITH_AFB_TRACE:=ON} \
	-DWITH_SUPERVISION=${WITH_SUPERVISION:=ON} \
	-DWITH_DYNAMIC_BINDING=${WITH_DYNAMIC_BINDING:=ON} \
	-DWITH_LIBMICROHTTPD=${WITH_LIBMICROHTTPD:=ON} \
	-DWITH_L4VSOCK=${WITH_L4VSOCK:=OFF} \
	-DWITH_CRED=${WITH_CRED:=ON} \
	-DWITH_REPLY_JOB=${WITH_REPLY_JOB:=ON} \
	-DWITH_ENVIRONMENT=${WITH_ENVIRONMENT:=ON} \
	-DWITH_AFB_DEBUG=${WITH_AFB_DEBUG:=ON} \
	-DWITH_CALL_PERSONALITY=${WITH_CALL_PERSONALITY:=ON} \
	-DWITH_AFB_CALL_SYNC=${WITH_AFB_CALL_SYNC:=ON} \
	-DWITH_API_CREATOR=${WITH_API_CREATOR:=ON} \
	-DWITH_REQ_PROCESS_ASYNC=${WITH_REQ_PROCESS_ASYNC:=ON} \
	-DWITH_CASE_FOLDING=${WITH_CASE_FOLDING:=OFF} \
	-DWITH_EXTENSION=${WITH_EXTENSION:=ON} \
	-DWITH_GNUTLS=${WITH_GNUTLS:=ON} \
	-DWITH_SIG_MONITOR_DUMPSTACK=${WITH_SIG_MONITOR_DUMPSTACK:=ON} \
	-DWITH_FDEV_POLL=${WITH_FDEV_POLL:=OFF} \
	-DWITH_FDEV_EPOLL=${WITH_FDEV_EPOLL:=OFF} \
	-DWITH_FDEV_SELECT=${WITH_FDEV_SELECT:=OFF} \
	-DWITH_FDEV_SYSTEMD=${WITH_FDEV_SYSTEMD:=${WITH_SYSTEMD}} \
	-DWITH_LOCALE_FOLDER=${WITH_LOCALE_FOLDER:=ON} \
	-DWITH_LOCALE_SEARCH_NODE=${WITH_LOCALE_SEARCH_NODE:=ON} \
	-DWITH_WSCLIENT_URI_COPY=${WITH_WSCLIENT_URI_COPY:=OFF} \
	-DWITH_FNMATCH=${WITH_FNMATCH:=ON} \
	-DWITH_LIBUUID=${WITH_LIBUUID:=ON} \
	-DWITH_EPOLL=${WITH_EPOLL:=ON} \
	-DWITH_EVENTFD=${WITH_EVENTFD:=ON} \
	-DWITH_CLOCK_GETTIME=${WITH_CLOCK_GETTIME:=ON} \
	-DWITH_RANDOM_R=${WITH_RANDOM_R:=ON} \
	-DWITH_OPENAT=${WITH_OPENAT:=ON} \
	-DWITH_DIRENT=${WITH_DIRENT:=ON} \
	-DWITH_SYS_UIO=${WITH_SYS_UIO:=ON} \
	-DWITH_REALPATH=${WITH_REALPATH:=ON} \
	-DWITH_UNIX_SOCKET=${WITH_UNIX_SOCKET:=ON} \
	-DWITH_THREAD_LOCAL=${WITH_THREAD_LOCAL:=ON} \
	-DWITH_LIBMAGIC=${WITH_LIBMAGIC:=ON} \
	-DARCH32=${ARCH32:=OFF} \
	-DWITH_RPUTILS_STATIC=${WITH_RPUTILS_STATIC:=OFF} \
	-WITH_BINDINGS_V3=${WITH_BINDINGS_V3:=ON} \
	-DWITH_WSJ1=${WITH_WSJ1:=ON} \
	-DWITH_WSAPI=${WITH_WSAPI:=ON} \
	-DWITH_RPC_V1=${WITH_RPC_V1:=ON} \
	-DWITH_RPC_V3=${WITH_RPC_V3:=ON} \
	-DWITH_TRACK_JOB_CALL=${WITH_TRACK_JOB_CALL:=ON} \
	-DWITHOUT_JSON_C=${WITHOUT_JSON_C:=OFF} \
	"$h"

make -j "$@"

